/**
 * 
 */
package de.bsvrz.buv.plugin.darstellung.editpolicies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import de.bsvrz.buv.plugin.darstellung.commands.DeleteDarstellungsSpalteCommand;
import de.bsvrz.buv.plugin.darstellung.model.DarstellungsSpalte;

/**
 * {@link ComponentEditPolicy} die das Lschen einer {@link DarstellungsSpalte}
 * steuert.
 * 
 * <p>
 * Jede Darstellungsspalte in einer stilisierten Darstellung kann gelscht
 * werden.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class DarstellungsSpalteEditPolicy extends ComponentEditPolicy {

	@Override
	protected Command createDeleteCommand(final GroupRequest deleteRequest) {
		final DarstellungsSpalte spalte = (DarstellungsSpalte) getHost()
				.getModel();
		return new DeleteDarstellungsSpalteCommand(spalte);
	}

}
