package de.bsvrz.buv.plugin.darstellung.figures;

import org.eclipse.draw2d.LayeredPane;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;

public class DarstellungFigure extends LayeredPane {

	private Dimension darstellungSize;

	public Dimension getDarstellungSize() {
		return darstellungSize;
	}

	public void setDarstellungSize(final Dimension darstellungSize) {
		if (this.darstellungSize == darstellungSize) {
			return;
		}

		this.darstellungSize = darstellungSize;
	}

	// TODO Lschen wenn #getBounds() berschrieben bleibt.
	@Override
	public Dimension getPreferredSize(final int wHint, final int hHint) {
		if (getDarstellungSize() != null) {
			return getDarstellungSize();
		}

		return super.getPreferredSize(wHint, hHint);
	}

	@Override
	public Rectangle getBounds() {
		if (getDarstellungSize() != null) {
			return new Rectangle(bounds.x, bounds.y, darstellungSize.width,
					darstellungSize.height);
		}
		return super.getBounds();
	}

	@Override
	protected boolean useLocalCoordinates() {
		return true;
	}

}
