package de.bsvrz.buv.plugin.darstellung.figures;

import org.eclipse.draw2d.AbstractBackground;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Layer;
import org.eclipse.draw2d.ScaledGraphics;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.swt.graphics.Image;

import com.bitctrl.lib.eclipse.draw2d.svg.SVGCache;

public class EbeneFigure extends Layer {

	private Image hintergrund;
	private SVGCache svgCache;
	private double hintergrundSkalierung;
	private Point hintergrundLocation;

	public EbeneFigure() {
		setLayoutManager(new XYLayout());
	}

	public SVGCache getSvgCache() {
		return svgCache;
	}

	public void setSvgCache(final SVGCache svgCache) {
		this.svgCache = svgCache;
		if (svgCache != null) {
			setHintergrund(null);
		}
	}

	public Image getHintergrund() {
		return hintergrund;
	}

	public void setHintergrund(final Image hintergrund) {
		this.hintergrund = hintergrund;
		if (hintergrund != null) {
			setSvgCache(null);
		}
	}

	public double getHintergrundSkalierung() {
		return hintergrundSkalierung;
	}

	public void setHintergrundSkalierung(final double hintergrundSkalierung) {
		this.hintergrundSkalierung = hintergrundSkalierung;
		repaint();
	}

	public Point getHintergrundLocation() {
		return hintergrundLocation;
	}

	public void setHintergrundLocation(final Point hintergrundLocation) {
		this.hintergrundLocation = hintergrundLocation;
	}

	@Override
	protected void paintFigure(final Graphics graphics) {
		// BEGIN: Copy from super Methode
		// Auskommentiert, weil Ebene sonst nicht mehr optisch transparent
		// if (isOpaque())
		// graphics.fillRectangle(getBounds());
		if (getBorder() instanceof AbstractBackground) {
			((AbstractBackground) getBorder()).paintBackground(this, graphics,
					NO_INSETS);
		}
		// END: Copy from super Methode

		if (hintergrund != null) {
			final Point location;
			if (getHintergrundLocation() != null) {
				location = getHintergrundLocation();
			} else {
				location = new Point();
			}

			if (graphics instanceof ScaledGraphics) {
				graphics.scale(hintergrundSkalierung);
			}
			graphics.drawImage(hintergrund, location);
		} else if (svgCache != null && svgCache.checkContentAvailable()) {
			final Image svgHintergrund = svgCache.createImage(getClientArea(),
					graphics);
			graphics.drawImage(svgHintergrund, getClientArea().getLocation());
			svgHintergrund.dispose();
		}
	}

}
