/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.darstellung.model;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Massstaebliche Darstellung</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMaximaleGeographischeBreite <em>Maximale Geographische Breite</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMinimaleGeographischeBreite <em>Minimale Geographische Breite</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMaximaleGeographischeLaenge <em>Maximale Geographische Laenge</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMinimaleGeographischeLaenge <em>Minimale Geographische Laenge</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getMassstaeblicheDarstellung()
 * @model
 * @generated
 */
public interface MassstaeblicheDarstellung extends Darstellung {

	/**
	 * Returns the value of the '<em><b>Maximale Geographische Breite</b></em>' attribute.
	 * The default value is <code>"55.1"</code>.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Maximale Geographische Breite</em>' attribute
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Maximale Geographische Breite</em>' attribute.
	 * @see #setMaximaleGeographischeBreite(double)
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getMassstaeblicheDarstellung_MaximaleGeographischeBreite()
	 * @model default="55.1"
	 * @generated
	 */
	double getMaximaleGeographischeBreite();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMaximaleGeographischeBreite <em>Maximale Geographische Breite</em>}' attribute.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Maximale Geographische Breite</em>' attribute.
	 * @see #getMaximaleGeographischeBreite()
	 * @generated
	 */
	void setMaximaleGeographischeBreite(double value);

	/**
	 * Returns the value of the '<em><b>Minimale Geographische Breite</b></em>' attribute.
	 * The default value is <code>"47.1"</code>.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Minimale Geographische Breite</em>' attribute
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Minimale Geographische Breite</em>' attribute.
	 * @see #setMinimaleGeographischeBreite(double)
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getMassstaeblicheDarstellung_MinimaleGeographischeBreite()
	 * @model default="47.1"
	 * @generated
	 */
	double getMinimaleGeographischeBreite();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMinimaleGeographischeBreite <em>Minimale Geographische Breite</em>}' attribute.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Minimale Geographische Breite</em>' attribute.
	 * @see #getMinimaleGeographischeBreite()
	 * @generated
	 */
	void setMinimaleGeographischeBreite(double value);

	/**
	 * Returns the value of the '<em><b>Maximale Geographische Laenge</b></em>' attribute.
	 * The default value is <code>"15.1"</code>.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Maximale Geographische Laenge</em>' attribute
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Maximale Geographische Laenge</em>' attribute.
	 * @see #setMaximaleGeographischeLaenge(double)
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getMassstaeblicheDarstellung_MaximaleGeographischeLaenge()
	 * @model default="15.1"
	 * @generated
	 */
	double getMaximaleGeographischeLaenge();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMaximaleGeographischeLaenge <em>Maximale Geographische Laenge</em>}' attribute.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Maximale Geographische Laenge</em>' attribute.
	 * @see #getMaximaleGeographischeLaenge()
	 * @generated
	 */
	void setMaximaleGeographischeLaenge(double value);

	/**
	 * Returns the value of the '<em><b>Minimale Geographische Laenge</b></em>' attribute.
	 * The default value is <code>"5.8"</code>.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Minimale Geographische Laenge</em>' attribute
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Minimale Geographische Laenge</em>' attribute.
	 * @see #setMinimaleGeographischeLaenge(double)
	 * @see de.bsvrz.buv.plugin.darstellung.model.DarstellungPackage#getMassstaeblicheDarstellung_MinimaleGeographischeLaenge()
	 * @model default="5.8"
	 * @generated
	 */
	double getMinimaleGeographischeLaenge();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.darstellung.model.MassstaeblicheDarstellung#getMinimaleGeographischeLaenge <em>Minimale Geographische Laenge</em>}' attribute.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Minimale Geographische Laenge</em>' attribute.
	 * @see #getMinimaleGeographischeLaenge()
	 * @generated
	 */
	void setMinimaleGeographischeLaenge(double value);
} // MassstaeblicheDarstellung
