package de.bsvrz.buv.plugin.dobj;

import org.eclipse.draw2d.geometry.Point;

/**
 * Hilfsklasse zum Bestimmen der Position eines Darstellungsobjekts.
 * 
 * <p>
 * Die Position eines Darstellungsobjekts kann als Position des Hotspots in der
 * Darstellung oder als Position der linken oberen Ecke der Bounds des
 * gezeichneten Darstellungsobjekts erfolgen.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public interface HotspotConverter {

	/**
	 * Rechnet die Position des Hotspots in der Darstellung in die linke obere
	 * Ecke der Bounds (der IFigure) um.
	 */
	Point convertModelToView(Point modelLocation);

	/**
	 * Rechnet die linke obere Ecke der Bounds (der IFigure) in die Position des
	 * Hotspots in der Darstellung um.
	 */
	Point convertViewToModel(Point viewLocation);

}
