package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.tools.EllipseSelectionTool;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;

/**
 * Action zum Aktivieren des {@link EllipseSelectionTool}.
 * 
 * @author BitCtrl Systems GmbH, Thierfelder
 * @version $Id$
 */
public class EllipseSelectionAction extends AbstractToolAction {

	/**
	 * Initialisiert die Action.
	 * 
	 * @param part
	 *            der Workbench Part fuer den die Action verwendet werden soll.
	 */
	public EllipseSelectionAction(final IWorkbenchPart part) {
		super(part, DobjMessages.EllipseSelection_Label,
				new EllipseSelectionTool());
		setToolTipText(DobjMessages.EllipseSelection_Tooltip);
		setId(DobjActionFactory.SELECTION_ELLIPSE.getCommandId());
		setActionDefinitionId(DobjActionFactory.SELECTION_ELLIPSE
				.getCommandId());
		setImageDescriptor(DobjIcons.ActionSelectionEllipse
				.getImageDescriptor());
	}
}
