package de.bsvrz.buv.plugin.dobj.actions;

import org.eclipse.ui.IWorkbenchPart;

import de.bsvrz.buv.plugin.dobj.internal.DobjMessages;
import de.bsvrz.buv.plugin.dobj.tools.PanTool;
import de.bsvrz.buv.plugin.dobj.util.DobjIcons;

/**
 * Action zum Aktivieren des {@link PanTool}.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class PanAction extends AbstractToolAction {

	/**
	 * Initialsiert die Action.
	 * 
	 * @param part
	 *            der Workbench Part fr den die Action verwendet werden soll.
	 */
	public PanAction(final IWorkbenchPart part) {
		super(part, DobjMessages.Pan_Label, new PanTool());
		setToolTipText(DobjMessages.Pan_Tooltip);
		setId(DobjActionFactory.PAN.getCommandId());
		setActionDefinitionId(DobjActionFactory.PAN.getCommandId());
		setImageDescriptor(DobjIcons.ActionPan.getImageDescriptor());
	}

}
