/**
 * Darstellungsobjekte - Decorator
 * Copyright (C) 2012 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */
package de.bsvrz.buv.plugin.dobj.decorator.model;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.swt.graphics.RGB;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Datenstatus Decorator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineQuelleFarbe <em>Keine Quelle Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineDatenFarbe <em>Keine Daten Farbe</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getNutzdatenFarbe <em>Nutzdaten Farbe</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getDatenstatusDecorator()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface DatenstatusDecorator extends EObject {
	/**
	 * Returns the value of the '<em><b>Keine Quelle Farbe</b></em>' attribute.
	 * The default value is <code>"128,128,128"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Keine Quelle Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Keine Quelle Farbe</em>' attribute.
	 * @see #isSetKeineQuelleFarbe()
	 * @see #unsetKeineQuelleFarbe()
	 * @see #setKeineQuelleFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getDatenstatusDecorator_KeineQuelleFarbe()
	 * @model default="128,128,128" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getKeineQuelleFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineQuelleFarbe <em>Keine Quelle Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Keine Quelle Farbe</em>' attribute.
	 * @see #isSetKeineQuelleFarbe()
	 * @see #unsetKeineQuelleFarbe()
	 * @see #getKeineQuelleFarbe()
	 * @generated
	 */
	void setKeineQuelleFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineQuelleFarbe <em>Keine Quelle Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetKeineQuelleFarbe()
	 * @see #getKeineQuelleFarbe()
	 * @see #setKeineQuelleFarbe(RGB)
	 * @generated
	 */
	void unsetKeineQuelleFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineQuelleFarbe <em>Keine Quelle Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Keine Quelle Farbe</em>' attribute is set.
	 * @see #unsetKeineQuelleFarbe()
	 * @see #getKeineQuelleFarbe()
	 * @see #setKeineQuelleFarbe(RGB)
	 * @generated
	 */
	boolean isSetKeineQuelleFarbe();

	/**
	 * Returns the value of the '<em><b>Keine Daten Farbe</b></em>' attribute.
	 * The default value is <code>"255,0,0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Keine Daten Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Keine Daten Farbe</em>' attribute.
	 * @see #isSetKeineDatenFarbe()
	 * @see #unsetKeineDatenFarbe()
	 * @see #setKeineDatenFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getDatenstatusDecorator_KeineDatenFarbe()
	 * @model default="255,0,0" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getKeineDatenFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineDatenFarbe <em>Keine Daten Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Keine Daten Farbe</em>' attribute.
	 * @see #isSetKeineDatenFarbe()
	 * @see #unsetKeineDatenFarbe()
	 * @see #getKeineDatenFarbe()
	 * @generated
	 */
	void setKeineDatenFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineDatenFarbe <em>Keine Daten Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetKeineDatenFarbe()
	 * @see #getKeineDatenFarbe()
	 * @see #setKeineDatenFarbe(RGB)
	 * @generated
	 */
	void unsetKeineDatenFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getKeineDatenFarbe <em>Keine Daten Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Keine Daten Farbe</em>' attribute is set.
	 * @see #unsetKeineDatenFarbe()
	 * @see #getKeineDatenFarbe()
	 * @see #setKeineDatenFarbe(RGB)
	 * @generated
	 */
	boolean isSetKeineDatenFarbe();

	/**
	 * Returns the value of the '<em><b>Nutzdaten Farbe</b></em>' attribute.
	 * The default value is <code>"0,255,0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Nutzdaten Farbe</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nutzdaten Farbe</em>' attribute.
	 * @see #isSetNutzdatenFarbe()
	 * @see #unsetNutzdatenFarbe()
	 * @see #setNutzdatenFarbe(RGB)
	 * @see de.bsvrz.buv.plugin.dobj.decorator.model.DobjDecoratorPackage#getDatenstatusDecorator_NutzdatenFarbe()
	 * @model default="0,255,0" unsettable="true" dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.RGB"
	 * @generated
	 */
	RGB getNutzdatenFarbe();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getNutzdatenFarbe <em>Nutzdaten Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nutzdaten Farbe</em>' attribute.
	 * @see #isSetNutzdatenFarbe()
	 * @see #unsetNutzdatenFarbe()
	 * @see #getNutzdatenFarbe()
	 * @generated
	 */
	void setNutzdatenFarbe(RGB value);

	/**
	 * Unsets the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getNutzdatenFarbe <em>Nutzdaten Farbe</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetNutzdatenFarbe()
	 * @see #getNutzdatenFarbe()
	 * @see #setNutzdatenFarbe(RGB)
	 * @generated
	 */
	void unsetNutzdatenFarbe();

	/**
	 * Returns whether the value of the '{@link de.bsvrz.buv.plugin.dobj.decorator.model.DatenstatusDecorator#getNutzdatenFarbe <em>Nutzdaten Farbe</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Nutzdaten Farbe</em>' attribute is set.
	 * @see #unsetNutzdatenFarbe()
	 * @see #getNutzdatenFarbe()
	 * @see #setNutzdatenFarbe(RGB)
	 * @generated
	 */
	boolean isSetNutzdatenFarbe();

} // DatenstatusDecorator
