/*
 * Rahmenwerk-Plug-in "Darstellungsobjekte"
 * Copyright (C) 2012 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

/**
 * Enthlt Klassen, mit denen Edit Parts die Decorator leicht untersttzen knnen.
 * 
 * <p>
 * Die Untersttzung basiert auf der Kapselung des Algorithmus zum bertragen
 * der Modellinformation in die View (Figure). Die Figure muss einer erwarteten
 * Schnittstelle entsprechen, damit ein Vermittlerobjekt (Mediator) den
 * Algorithmus durchfhren kann.
 * 
 * <p>
 * Fr einige Decorator kennt Draw2D bereits eine eigene Schnittstellen:
 * <ul>
 * <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.VordergrundfarbeDecorator} wird durch {@link org.eclipse.draw2d.IFigure#setForegroundColor(org.eclipse.swt.graphics.Color)} abgedeckt</li>
 * <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.HintergrundfarbeDecorator} wird durch {@link org.eclipse.draw2d.IFigure#setBackgroundColor(org.eclipse.swt.graphics.Color)} abgedeckt</li>
 * <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.SchriftDecorator} wird durch {@link org.eclipse.draw2d.IFigure#setFont(org.eclipse.swt.graphics.Font)} abgedeckt</li>
 * <li>{@link de.bsvrz.buv.plugin.dobj.decorator.model.SkalierungDecorator} wird durch {@link org.eclipse.draw2d.ScalableFigure} abgedeckt</li>
 * </ul>
 */
package de.bsvrz.buv.plugin.dobj.decorator;

