package de.bsvrz.buv.plugin.dobj.editors;

import org.eclipse.gef.ui.actions.ActionBarContributor;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.gef.ui.actions.MatchHeightRetargetAction;
import org.eclipse.gef.ui.actions.MatchWidthRetargetAction;
import org.eclipse.gef.ui.actions.ZoomComboContributionItem;
import org.eclipse.gef.ui.actions.ZoomInRetargetAction;
import org.eclipse.gef.ui.actions.ZoomOutRetargetAction;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.actions.ActionFactory;

import de.bsvrz.buv.plugin.dobj.actions.DobjActionFactory;

/**
 * Kann als Basisklasse fr {@link ActionBarContributor}s verwendet werden.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class DobjActionBarContributor extends ActionBarContributor {

	/** Name der Gruppe fr Auswahlwerkzeuge. */
	public static final String GROUP_SELECTION = "selection";

	/** Name der Gruppe fr Zoomwerkzeuge. */
	public static final String GROUP_ZOOM = "zoom";

	@Override
	protected void buildActions() {
		// Grenanpassung
		addRetargetAction(new MatchWidthRetargetAction());
		addRetargetAction(new MatchHeightRetargetAction());

		// Zoomen
		addRetargetAction(DobjActionFactory.PAN.create());
		addRetargetAction(DobjActionFactory.ZOOM_RECTANGLE.create());
		addRetargetAction(new ZoomInRetargetAction());
		addRetargetAction(new ZoomOutRetargetAction());
	}

	@Override
	public void contributeToToolBar(final IToolBarManager toolBarManager) {
		toolBarManager.add(getAction(DobjActionFactory.PAN.getCommandId()));

		toolBarManager.add(new Separator(GROUP_SELECTION));
		toolBarManager.add(new Separator(GROUP_ZOOM));

		toolBarManager.appendToGroup(GROUP_ZOOM,
				getAction(DobjActionFactory.ZOOM_RECTANGLE.getCommandId()));
		toolBarManager.appendToGroup(GROUP_ZOOM,
				getAction(GEFActionConstants.ZOOM_IN));
		toolBarManager.appendToGroup(GROUP_ZOOM,
				getAction(GEFActionConstants.ZOOM_OUT));
		toolBarManager.appendToGroup(GROUP_ZOOM, new ZoomComboContributionItem(
				getPage()));
	}

	@Override
	protected void declareGlobalActionKeys() {
		// XXX Drucken im Rahmenwerk entfernen?
		addGlobalActionKey(ActionFactory.PRINT.getCommandId());
		addGlobalActionKey(ActionFactory.SELECT_ALL.getCommandId());
	}

}
