/*
 * Rahmenwerk-Plug-in "Darstellungsobjekte"
 * Copyright (C) 2009 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.dobj.kollision;

import org.eclipse.draw2d.geometry.Rectangle;

/**
 * Schnittstelle zu einem Objekt, dessen "Extra-Bounds" nicht von einem anderen
 * ueberdeckt werden duerfen (bzw. umgedreht).
 * 
 * @author BitCtrl Systems GmbH, thierfelder
 * @version $Id$
 */
public interface IArrangierbaresObjektMitExtraBounds extends IArrangierbar {

	/**
	 * Gibt den Bereich des Objekts zurck, der sich nicht mit anderen
	 * berdecken soll.
	 */
	public Rectangle getExtraBounds();

}
