/**
 * Darstellungsobjekte
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weienfelser Strae 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 *
 * $Id$
 */
package de.bsvrz.buv.plugin.dobj.model;

import org.eclipse.core.runtime.IConfigurationElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Configurated Do Typ</b></em>'. <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.ConfiguratedDoTyp#getConfigurationElement <em>Configuration Element</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.dobj.model.ConfiguratedDoTyp#isNurMassstaeblicheDarstellung <em>Nur Massstaebliche Darstellung</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getConfiguratedDoTyp()
 * @model
 * @generated
 */
public interface ConfiguratedDoTyp extends DoTyp {

	/**
	 * Returns the value of the '<em><b>Configuration Element</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Configuration Element</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Configuration Element</em>' attribute.
	 * @see #setConfigurationElement(IConfigurationElement)
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getConfiguratedDoTyp_ConfigurationElement()
	 * @model dataType="com.bitctrl.lib.eclipse.emf.eclipse.model.IConfigurationElement" required="true"
	 * @generated
	 */
	IConfigurationElement getConfigurationElement();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.ConfiguratedDoTyp#getConfigurationElement <em>Configuration Element</em>}' attribute.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Configuration Element</em>' attribute.
	 * @see #getConfigurationElement()
	 * @generated
	 */
	void setConfigurationElement(IConfigurationElement value);

	/**
	 * Returns the value of the '<em><b>Nur Massstaebliche Darstellung</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Nur Massstaebliche Darstellung</em>' attribute
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nur Massstaebliche Darstellung</em>' attribute.
	 * @see #setNurMassstaeblicheDarstellung(boolean)
	 * @see de.bsvrz.buv.plugin.dobj.model.DobjPackage#getConfiguratedDoTyp_NurMassstaeblicheDarstellung()
	 * @model default="false" transient="true"
	 * @generated
	 */
	boolean isNurMassstaeblicheDarstellung();

	/**
	 * Sets the value of the '{@link de.bsvrz.buv.plugin.dobj.model.ConfiguratedDoTyp#isNurMassstaeblicheDarstellung <em>Nur Massstaebliche Darstellung</em>}' attribute.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nur Massstaebliche Darstellung</em>' attribute.
	 * @see #isNurMassstaeblicheDarstellung()
	 * @generated
	 */
	void setNurMassstaeblicheDarstellung(boolean value);
} // ConfiguratedDoTyp
