package de.bsvrz.buv.plugin.dobj.requests;

import org.eclipse.gef.Request;

/**
 * Request zur Aufforderung des Ein- und Auschaltens des Filters fuer
 * <b>alle</b> gueltige Baustellen.
 * 
 * @author BitCtrl Systems GmbH, Thomas Thierfelder
 * @version $Id$
 */
public class BaustelleGueltigRequest extends Request {

	private final boolean baustelleGueltig;

	/**
	 * Initialisiert den Request.
	 * 
	 * @param baustelleGueltig
	 *            das Flag ob der Filter fuer <b>alle</b> gueltige Baustellen
	 *            gesetzt ist.
	 */
	public BaustelleGueltigRequest(final boolean baustelleGueltig) {
		super(DobjRequestConstants.REQ_BAUSTELLE_GUELTIG);
		this.baustelleGueltig = baustelleGueltig;
	}

	/**
	 * Erfragt, ob alle gueltigen Baustellen eingeblendet werden sollen.
	 * 
	 * @return ob alle gueltigen Baustellen eingeblendet werden sollen.
	 */
	public boolean isAlleGueltigenBaustellenAnzeigen() {
		return baustelleGueltig;
	}

}
