package de.bsvrz.buv.plugin.dobj.requests;

/**
 * Enthlt die Konstanten der GEF-Requests des Plug-ins.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id: DobjRequestConstants.java 28772 2011-03-14 17:18:10Z tfelder $
 */
public interface DobjRequestConstants {

	/**
	 * Request zum Ein- und Ausschalten der Verbindungslinie eines verschobenen
	 * Objekts zu seiner Originalposition.
	 */
	String REQ_VERBINDUNGSLINIE = "Verbindungslinie";

	/**
	 * Request zum Ein- und Ausschalten des Filters zum Anzeigen aller gueltigen
	 * Baustellen.
	 */
	String REQ_BAUSTELLE_GUELTIG = "Baustellegueltig";

	/**
	 * Request zum umschalten zwischen Online- und Offlinemodus von Edit Parts.
	 */
	String REQ_ONLINE = "Online";

	/*
	 * TODO Flag (EMF-Property) ob der Antikollisionsalgorithmus verwendet
	 * werden sollte vom Netz-Plug-in ins DObj-Plug-in verschieben.
	 * 
	 * XXX Sollte das Flag nicht Antikollisionsalgorithmus heien? Schlielich
	 * sollen Kollisionen vermieden werden.
	 */
	String REQ_KOLLISIONSALGORITHMUS = "Kollisionsalgorithmus";

}
