package de.bsvrz.buv.plugin.dobj.util;

import java.util.EventObject;

import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.Bild;

/**
 * Dieses Event wird verteilt, wenn sich die in der Konfiguration des
 * Datenverteilers vorhandenen {@link Bild}er gendert haben.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class BildEvent extends EventObject {

	private static final long serialVersionUID = 1L;

	private Bild bild;

	/**
	 * Initialisiert das Event.
	 * 
	 * @param source
	 *            die Quelle des Events.
	 * @param bild
	 *            das Bild, das sich gendert hat.
	 */
	public BildEvent(BildManager source, Bild bild) {
		super(source);
		this.bild = bild;
	}

	/**
	 * Das Bild, das sich gendert zurck.
	 * 
	 * @return das gendert Bild.
	 */
	public Bild getBild() {
		return bild;
	}

}
