package de.bsvrz.buv.plugin.dobj.util;

import java.util.EventListener;

import de.bsvrz.sys.funclib.bitctrl.modell.bitctrlallgemein.objekte.Bild;

/**
 * Listener fr nderungen an den vorhandenen {@link Bild}ern in der
 * Konfiguration des Datenverteilers.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public interface BildListener extends EventListener {

	/**
	 * Ein Bild wurde neu angelegt.
	 * 
	 * @param e
	 *            das Event mit dem neuen Bild.
	 */
	void bildAngelegt(BildEvent e);

	/**
	 * Ein vorhandenes Bild wurde gelscht.
	 * 
	 * @param e
	 *            das Event mit dem gelschten Bild.
	 */
	void bildEntfernt(BildEvent e);

	/**
	 * Ein vorhandenes Bild wurde umbenannt.
	 * 
	 * @param e
	 *            das Event mit dem umbenannten Bild.
	 */
	void bildUmbenannt(BildEvent e);

	/**
	 * der Zustand der Verbindung zur Verwaltung der Bilde rhat sich gendert.
	 * 
	 * @param e
	 *            das Event
	 */
	void bildConnection(BildEvent e);

}
