package de.bsvrz.buv.plugin.dobj.util;

import org.eclipse.draw2d.geometry.Point;

/**
 * Eine Projektion wird fr die Darstellung bentigt, um zwischen Welt und
 * Modellkorrdinaten umzurechnen. Modellkoordinaten sind immer die
 * Bildschirmkoordinaten in Pixel, mit denen GEF/Draw2d arbeitet.
 * Weltkoordinaten knnen z.&nbsp;B. WGS-84-Koordinaten sein.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public interface Projektion {

	/**
	 * Rechnet einen Punkt in Weltkoordinaten in die entsprechenden
	 * Modellkoordinaten um.
	 * 
	 * @param welt
	 *            ein Punkt in Weltkoordinaten.
	 * @return der entsprechenden Punkt in Modellkoordinaten.
	 */
	Point umrechnenWeltNachModel(Point welt);

	/**
	 * Rechnet einen Punkt in Modellkoordinaten in die entsprechenden
	 * Weltkoordinaten um.
	 * 
	 * @param modell
	 *            ein Punkt in Modellkoordinaten.
	 * @return der entsprechenden Punkt in Weltkoordinaten.
	 */
	Point umrechnenModellNachWelt(Point modell);

}
