package de.bsvrz.buv.plugin.doeditor.editpolicies;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;

import com.bitctrl.lib.eclipse.gef.editpolicies.OnlySelectionEditPolicy;

import de.bsvrz.buv.plugin.doeditor.model.EditorDoModel;

/**
 * Layout Policy fr {@link EditorDoModel}.
 * 
 * <p>
 * Die Policy sorgt nur dafr, das alle eingebetteten Objekte selektierbar sind.
 * Es werden keine Bearbeitungsmglichekiten untersttzt.
 * 
 * @author BitCtrl Systems GmbH, Falko Schumann
 * @version $Id$
 */
public class EditorDoModelLayoutEditPolicy extends LayoutEditPolicy {

	@Override
	protected EditPolicy createChildEditPolicy(final EditPart child) {
		return new OnlySelectionEditPolicy();
	}

	@Override
	protected Command getCreateCommand(final CreateRequest request) {
		return null;
	}

	@Override
	protected Command getMoveChildrenCommand(final Request request) {
		return null;
	}

}
