/*
 * Rahmenwerk-Plug-in "Darstellungsobjekttyp-Editor"
 * Copyright (C) 2010 BitCtrl Systems GmbH 
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weissenfelser Strasse 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.buv.plugin.doeditor.model.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.bsvrz.buv.plugin.doeditor.model.DoeditorPackage;
import de.bsvrz.buv.plugin.doeditor.model.SichtbarkeitAttributeTextDecorator;

/**
 * This is the item provider adapter for a {@link de.bsvrz.buv.plugin.doeditor.model.SichtbarkeitAttributeTextDecorator} object.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class SichtbarkeitAttributeTextDecoratorItemProvider extends
		ItemProviderAdapter implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider,
		IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public SichtbarkeitAttributeTextDecoratorItemProvider(
			AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addSichtbarPropertyDescriptor(object);
			addTextPropertyDescriptor(object);
			addAttributGruppePropertyDescriptor(object);
			addAspektPropertyDescriptor(object);
			addAttributPfadPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Sichtbar feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addSichtbarPropertyDescriptor(Object object) {
		itemPropertyDescriptors
				.add(createItemPropertyDescriptor(
						((ComposeableAdapterFactory) adapterFactory)
								.getRootAdapterFactory(),
						getResourceLocator(),
						getString("_UI_SichtbarkeitParameterDefinition_sichtbar_feature"),
						getString(
								"_UI_PropertyDescriptor_description",
								"_UI_SichtbarkeitParameterDefinition_sichtbar_feature",
								"_UI_SichtbarkeitParameterDefinition_type"),
						DoeditorPackage.Literals.SICHTBARKEIT_PARAMETER_DEFINITION__SICHTBAR,
						true, false, false,
						ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Text feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTextPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_TextDecorator_text_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_TextDecorator_text_feature",
						"_UI_TextDecorator_type"),
				DoeditorPackage.Literals.TEXT_DECORATOR__TEXT, true, false,
				false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Attribut Gruppe feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addAttributGruppePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_AttributeDecorator_attributGruppe_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_AttributeDecorator_attributGruppe_feature",
						"_UI_AttributeDecorator_type"),
				DoeditorPackage.Literals.ATTRIBUTE_DECORATOR__ATTRIBUT_GRUPPE,
				true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				null, null));
	}

	/**
	 * This adds a property descriptor for the Aspekt feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addAspektPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_AttributeDecorator_aspekt_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_AttributeDecorator_aspekt_feature",
						"_UI_AttributeDecorator_type"),
				DoeditorPackage.Literals.ATTRIBUTE_DECORATOR__ASPEKT, true,
				false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null,
				null));
	}

	/**
	 * This adds a property descriptor for the Attribut Pfad feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addAttributPfadPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(
				((ComposeableAdapterFactory) adapterFactory)
						.getRootAdapterFactory(),
				getResourceLocator(),
				getString("_UI_AttributeDecorator_attributPfad_feature"),
				getString("_UI_PropertyDescriptor_description",
						"_UI_AttributeDecorator_attributPfad_feature",
						"_UI_AttributeDecorator_type"),
				DoeditorPackage.Literals.ATTRIBUTE_DECORATOR__ATTRIBUT_PFAD,
				true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				null, null));
	}

	/**
	 * This returns SichtbarkeitAttributeTextDecorator.gif.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(
				object,
				getResourceLocator().getImage(
						"full/obj16/SichtbarkeitAttributeTextDecorator"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		SichtbarkeitAttributeTextDecorator sichtbarkeitAttributeTextDecorator = (SichtbarkeitAttributeTextDecorator) object;
		return getString("_UI_SichtbarkeitAttributeTextDecorator_type") + " "
				+ sichtbarkeitAttributeTextDecorator.isSichtbar();
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification
				.getFeatureID(SichtbarkeitAttributeTextDecorator.class)) {
		case DoeditorPackage.SICHTBARKEIT_ATTRIBUTE_TEXT_DECORATOR__SICHTBAR:
		case DoeditorPackage.SICHTBARKEIT_ATTRIBUTE_TEXT_DECORATOR__TEXT:
		case DoeditorPackage.SICHTBARKEIT_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_GRUPPE:
		case DoeditorPackage.SICHTBARKEIT_ATTRIBUTE_TEXT_DECORATOR__ASPEKT:
		case DoeditorPackage.SICHTBARKEIT_ATTRIBUTE_TEXT_DECORATOR__ATTRIBUT_PFAD:
			fireNotifyChanged(new ViewerNotification(notification,
					notification.getNotifier(), false, true));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(
			Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

	/**
	 * Return the resource locator for this item provider's resources. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return DoeditorEditPlugin.INSTANCE;
	}

}
